package com.github.livepvrdata.monitors.mlb

import groovy.json.JsonSlurper

String getFeed(Date date) throws IOException {
	TimeZone FEED_TIME_ZONE = TimeZone.getTimeZone('America/New_York')
	String FEED_URL = 'http://mlb.mlb.com/gdcross/components/game/mlb/year_%s/month_%s/day_%s/master_scoreboard.json'

	String dateStr = date.format('yyyy|MM|dd', FEED_TIME_ZONE)
	def input = dateStr.split('\\|')
	try {
		String urlSpec = String.format(FEED_URL, input[0], input[1], input[2])
		println "urlSpec = " + urlSpec
		def mlbURL = new URL (urlSpec)
		def data = mlbURL.text
		def parsedData = parseFeed(data)
	} catch(Throwable t) {
		println "Error fetching data" + t
	}
	dateStr
}

String parseFeed(String data) throws IOException {
	try {
		if(data) {
			def json = new JsonSlurper().parseText(data)
			if(json.data.games.game instanceof Map)
				json.data.games.game = [json.data.games.game]
			println ""
			json.data.games.game.each {
				def tz = it.time_zone_hm_lg.toInteger()
				def pad = tz < 0 ? 3 : 2
				def start = "${it.time_date_hm_lg} ${it.hm_lg_ampm} ${String.format("%0${pad}d", tz)}00"
				println "======================="
				println "tz: " + tz + " pad: " + pad + " start: " + start
				println it.away_team_city + " at " + it.home_team_city
				println ""
			}
		}
		return data
	} catch(Exception e) {
		println "caught exception in parseFeed " + e
		throw new IOException(e)
	}
}

Date date = new Date ()
def events = getFeed (date)